const int PARTY = FALSE;
const string ERROR = "You're not poisoned";

void main(int iTarget)
{
	object oTarget = IntToObject(iTarget);
	effect eLink = EffectLinkEffects(EffectVisualEffect(VFX_IMP_HEALING_S), EffectHeal(d8(4)+9));
	int bValid = FALSE;
	
		if(PARTY)
		{
			object oCurrent = GetFirstFactionMember(oTarget, FALSE);
			while(GetIsObjectValid(oCurrent))
			{
			    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
			    effect ePoison = GetFirstEffect(oCurrent);
			    while(GetIsEffectValid(ePoison))
			    {
			        if (GetEffectType(ePoison) == EFFECT_TYPE_POISON)
			        {
			            RemoveEffect(oCurrent, ePoison);
			           	bValid = TRUE;
			        }
			        GetNextEffect(oCurrent);
					
					if (bValid)
				        ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oCurrent);
			    }				
				oCurrent = GetNextFactionMember(oTarget, FALSE);
			}
		}
		else
		{
		    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
		    effect ePoison = GetFirstEffect(oTarget);
		    while(GetIsEffectValid(ePoison))
		    {
		        if (GetEffectType(ePoison) == EFFECT_TYPE_POISON)
		        {
		            RemoveEffect(oTarget, ePoison);
		            bValid = TRUE;
		        }
		        GetNextEffect(oTarget);
				
				if (bValid)
					ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);
		    }				
		}
		
		if (!bValid)
			//TakeGoldFromCreature(PRICE, oTarget, TRUE);
		//else
			SendMessageToPC(oTarget, ERROR);
}