const int PRICE = 750;
const int PARTY = FALSE;
const string MESSAGE = "Non enough gold";
const string ERROR = "You're not diseased";

void main(int iTarget)
{
	object oTarget = IntToObject(iTarget);
	effect eLink = EffectLinkEffects(EffectVisualEffect(VFX_IMP_HEALING_S), EffectHeal(d8(4)+9));
	int bValid = FALSE;
	
	if (GetGold(oTarget) >= PRICE)
	{
		if(PARTY)
		{			
			object oCurrent = GetFirstFactionMember(oTarget, FALSE);
			while(GetIsObjectValid(oCurrent))
			{
			    effect eDisease = GetFirstEffect(oCurrent);
			    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
			    while(GetIsEffectValid(eDisease))
			    {
			        if (GetEffectType(eDisease) == EFFECT_TYPE_DISEASE)
			        {
			            RemoveEffect(oCurrent, eDisease);
			            bValid = TRUE;
			        }
			        GetNextEffect(oCurrent);
			    }
			    if (bValid)
			        ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oCurrent);
					
				oCurrent = GetNextFactionMember(oTarget, FALSE);
			}
		}
		else
		{

		    effect eDisease = GetFirstEffect(oTarget);
		    effect eVis = EffectVisualEffect(VFX_IMP_REMOVE_CONDITION);
		    while(GetIsEffectValid(eDisease))
		    {
		        if (GetEffectType(eDisease) == EFFECT_TYPE_DISEASE)
		        {
		            RemoveEffect(oTarget, eDisease);
		            bValid = TRUE;
		        }
		        GetNextEffect(oTarget);
		    }
		    if (bValid)
		        ApplyEffectToObject(DURATION_TYPE_INSTANT, eVis, oTarget);	
		}
		
		if (bValid)
			TakeGoldFromCreature(PRICE, oTarget, TRUE);
		else
			SendMessageToPC(oTarget, ERROR);
	}
	else
		SendMessageToPC(oTarget, MESSAGE);
}